SystemOrganization addCategory: #'XML-Parser-GemstoneCompatibility'!

!Collection methodsFor: '*XML-Parser-GemstoneCompatibility' stamp: 'monty 2/18/2016 04:55'!
capacity
	^ self size! !

!GsFile methodsFor: '*XML-Parser-GemstoneCompatibility' stamp: 'monty 12/18/2014 18:27'!
isStream
	^ true! !

!CharacterCollection methodsFor: '*XML-Parser-GemstoneCompatibility' stamp: 'monty 4/21/2016 08:22'!
asXMLEscapedString
	"returns a copy of self with &, <, and > escaped with &amp;, &lt;, and &gt;"
	| stream |

	stream := (self class new: self size) writeStream.
	"to:do: for performance"
	1 to: self size do: [:i | | nextChar |
		(nextChar := self at: i) == $<
			ifTrue: [stream nextPutAll: '&lt;']
			ifFalse: [
				nextChar == $> "needed to escape ]]> in PCDATA"
					ifTrue: [stream nextPutAll: '&gt;']
					ifFalse: [
						nextChar == $&
							ifTrue: [stream nextPutAll: '&amp;']
							ifFalse: [stream nextPut: nextChar]]]].
	^ stream contents.! !

!CharacterCollection methodsFor: '*XML-Parser-GemstoneCompatibility' stamp: 'monty 4/21/2016 08:22'!
asXMLFileHandle
	^ XMLFileHandle path: self! !

!CharacterCollection methodsFor: '*XML-Parser-GemstoneCompatibility' stamp: 'monty 4/21/2016 08:22'!
asXMLHTTPRequest
	^ XMLHTTPRequest url: self! !

!CharacterCollection methodsFor: '*XML-Parser-GemstoneCompatibility' stamp: 'monty 4/21/2016 08:22'!
asXMLStreamConverter
	^ XMLStreamConverter newForEncoding: self! !

!CharacterCollection methodsFor: '*XML-Parser-GemstoneCompatibility' stamp: 'monty 8/17/2016 02:19'!
asXMLString
	"will be deprecated; use #asXMLStringNode instead"

	^ self asXMLStringNode! !

!CharacterCollection methodsFor: '*XML-Parser-GemstoneCompatibility' stamp: 'monty 8/17/2016 02:19'!
asXMLStringNode
	^ XMLString string: self! !

!CharacterCollection methodsFor: '*XML-Parser-GemstoneCompatibility' stamp: 'monty 4/21/2016 08:22'!
asXMLURI
	^ XMLURI fromString: self! !

!CharacterCollection methodsFor: '*XML-Parser-GemstoneCompatibility' stamp: 'monty 4/21/2016 08:22'!
expandWithXMLNamespaceURI: aURI
	aURI size > 0
		ifTrue: [^ 'Q{', aURI, '}', self]
		ifFalse: [^ self]! !

!CharacterCollection methodsFor: '*XML-Parser-GemstoneCompatibility' stamp: 'monty 4/21/2016 08:22'!
isXMLNCName
	"optimized"
	self size > 0
		ifFalse: [^ false].
	(self at: 1) isXMLNCNameStartChar
		ifFalse: [^ false].
	2 to: self size do: [:i |
		(self at: i) isXMLNCNameChar
			ifFalse: [^ false]].
	^ true.! !

!CharacterCollection methodsFor: '*XML-Parser-GemstoneCompatibility' stamp: 'monty 4/21/2016 08:22'!
isXMLNSAttributeName
	"optimized"
	self size >= 5
		ifFalse: [^ false].
	(self at: 1) == $x
		ifFalse: [^ false].
	(self at: 2) == $m
		ifFalse: [^ false].
	(self at: 3) == $l
		ifFalse: [^ false].
	(self at: 4) == $n
		ifFalse: [^ false].
	(self at: 5) == $s
		ifFalse: [^ false].
	self size = 5
		ifTrue: [^ true].
	^ (self at: 6) == $:.! !

!CharacterCollection methodsFor: '*XML-Parser-GemstoneCompatibility' stamp: 'monty 4/21/2016 08:22'!
isXMLName
	"optimized"
	self size > 0
		ifFalse: [^ false].
	(self at: 1) isXMLNameStartChar
		ifFalse: [^ false].
	2 to: self size do: [:i |
		(self at: i) isXMLNameChar
			ifFalse: [^ false]].
	^ true.! !

!CharacterCollection methodsFor: '*XML-Parser-GemstoneCompatibility' stamp: 'monty 4/21/2016 08:22'!
isXMLNmtoken
	"optimized"
	self size > 0
		ifFalse: [^ false].
	1 to: self size do: [:i |
		(self at: i) isXMLNameChar
			ifFalse: [^ false]].
	^ true.! !

!CharacterCollection methodsFor: '*XML-Parser-GemstoneCompatibility' stamp: 'monty 4/21/2016 08:22'!
isXMLQualifiedOrLocalName: aQualifiedOrLocalName
	"returns true if self and aQualifiedOrLocalName are the
	same QName or if self is a QName and aQualifiedOrLocalName
	is the local part, or if they are the same NCName."
	| i |

	i := aQualifiedOrLocalName size.
	self size to: 1 by: -1 do: [:j |
		i > 0
			ifFalse: [^ (self at: j) == $:].
		(aQualifiedOrLocalName at: i) = (self at: j)
			ifFalse: [^ false].
		i := i - 1].
	^ i = 0.! !

!CharacterCollection methodsFor: '*XML-Parser-GemstoneCompatibility' stamp: 'monty 4/21/2016 08:22'!
isXMLReservedAttributeName
	"optimized"
	self size > 3
		ifFalse: [^ false].
	(self at: 1) == $x
		ifFalse: [^ false].
	(self at: 2) == $m
		ifFalse: [^ false].
	^ (self at: 3) == $l.! !

!CharacterCollection methodsFor: '*XML-Parser-GemstoneCompatibility' stamp: 'monty 4/21/2016 08:22'!
isXMLWhitespace
	"optimized"
	self size > 0
		ifFalse: [^ false].
	1 to: self size do: [:i |
		(self at: i) isXMLWhitespace
			ifFalse: [^ false]].
	^ true.! !

!CharacterCollection methodsFor: '*XML-Parser-GemstoneCompatibility' stamp: 'monty 4/21/2016 08:22'!
parseXML
	^ XMLDOMParser parse: self! !

!CharacterCollection methodsFor: '*XML-Parser-GemstoneCompatibility' stamp: 'monty 4/21/2016 08:22'!
qualifyWithXMLPrefix: aPrefix
	"optimized"
	aPrefix size > 0
		ifTrue: [^ (aPrefix copyWith: $:), self]
		ifFalse: [^ self]! !

!CharacterCollection methodsFor: '*XML-Parser-GemstoneCompatibility' stamp: 'monty 4/21/2016 08:22'!
xmlLocalNameAfterPrefix
	^ self xmlLocalNameAfterPrefix: self xmlPrefixBeforeLocalName! !

!CharacterCollection methodsFor: '*XML-Parser-GemstoneCompatibility' stamp: 'monty 4/21/2016 08:22'!
xmlLocalNameAfterPrefix: aPrefix
	"optimized"
	| prefixSize |

	(prefixSize := aPrefix size) > 0
		ifTrue: [^ self copyFrom: prefixSize + 2 to: self size]
		ifFalse: [^ self]! !

!CharacterCollection methodsFor: '*XML-Parser-GemstoneCompatibility' stamp: 'monty 4/21/2016 08:22'!
xmlPrefixBeforeLocalName
	"Split the name into namespace prefix
	(Optimized code)"
	| i |

	i := self size.
	[i > 1]
		whileTrue: [
			((self at: i) == $:)
				ifTrue: [^ (self copyFrom: 1 to: i - 1)].
			i := i - 1].
	^ ''.! !

!CharacterCollection methodsFor: '*XML-Parser-GemstoneCompatibility' stamp: 'monty 4/21/2016 08:22'!
xmlPrefixBeforeLocalName: aLocalName
	"optimized"
	| prefixSize |

	(prefixSize := self size - aLocalName size - 1) > 0
		ifTrue: [^ self copyFrom: 1 to: prefixSize]
		ifFalse: [^ '']! !
